import '@nativescript/macos-node-api';
import { Event } from '../../dom/dom-utils.js';
import { YogaNodeLayout } from '../../layout/index.js';
import { View } from '../view/view.js';
export declare class WebviewNavigationEvent extends Event {
    url?: string | URL;
    navigationType?: WebViewNavigationType;
    constructor(type: string, url: string | URL, navigationType: WebViewNavigationType, eventDict?: EventInit);
}
export declare class LoadStartedEvent extends WebviewNavigationEvent {
    constructor(url: string | URL, navigationType: WebViewNavigationType, eventDict?: EventInit);
}
export declare class LoadFinishedEvent extends WebviewNavigationEvent {
    constructor(url: string | URL, eventDict?: EventInit);
}
export declare class WebViewMessageEvent extends Event {
    data: any;
    constructor(data: any, eventDict?: EventInit);
}
type WebViewNavigationType = "linkClicked" | "formSubmitted" | "backForward" | "reload" | "formResubmitted" | "other" | undefined;
declare class WebViewDelegate extends NSObject implements WKUIDelegate, WKNavigationDelegate, WKScriptMessageHandler {
    static ObjCProtocols: (typeof WKUIDelegate | typeof WKNavigationDelegate | typeof WKScriptMessageHandler)[];
    _owner: WeakRef<WebView>;
    static initWithOwner(owner: WeakRef<WebView>): WebViewDelegate;
    webViewCreateWebViewWithConfigurationForNavigationActionWindowFeatures(webView: WKWebView, _configuration: WKWebViewConfiguration, navigationAction: WKNavigationAction, _windowFeatures: WKWindowFeatures): WKWebView;
    webViewDecidePolicyForNavigationActionDecisionHandler(_webView: WKWebView, navigationAction: WKNavigationAction, decisionHandler: (p1: interop.Enum<typeof WKNavigationActionPolicy>) => void): void;
    webViewDidFinishNavigation(webView: WKWebView, _navigation: WKNavigation): void;
    userContentControllerDidReceiveScriptMessage(userContentController: WKUserContentController, message: WKScriptMessage): void;
    attachMessageHandler(): void;
    detachMessageHandler(): void;
}
export declare class WebView extends View {
    get isLeaf(): boolean;
    delegate: WebViewDelegate;
    postMessageScript?: WKUserScript;
    nativeView?: WKWebView;
    initNativeView(): WKWebView | undefined;
    prepareNativeView(_nativeView: any): void;
    applyLayout(parentLayout?: YogaNodeLayout): void;
    loadURL(value: string | URL): void;
    executeJavaScript(src: string): void;
    sendEvent(type: string, data: any): void;
    postMessage(data: any): void;
    src: string | URL;
    debug: boolean;
    disposeNativeView(): void;
    messagingEnabled: boolean;
}
export {};
